#include "../src/babychess.cc"
#include "../src/alpha_pixmap.cc"
#include "../src/arg_main.cc"
#include "../src/ask_dialog.cc"
#include "../src/bevel.cc"
#include "../src/board.cc"
#include "../src/board_settings_editor.cc"
#include "../src/board_settings_stream.cc"
#include "../src/book.cc"
#include "../src/busy.cc"
#include "../src/button.cc"
#include "../src/canvas.cc"
#include "../src/check_box.cc"
#include "../src/chess_info_widget.cc"
#include "../src/child_process.cc"
#include "../src/clock.cc"
#include "../src/color_chooser.cc"
#include "../src/color_widget.cc"
#include "../src/conf.cc"
#include "../src/conf_menu.cc"
#include "../src/constant.cc"
#include "../src/context_menu.cc"
#include "../src/dialog.cc"
#include "../src/dir.cc"
#include "../src/document.cc"
#include "../src/document_editor.cc"
#include "../src/drawing_area.cc"
#include "../src/editor_window.cc"
#include "../src/engine.cc"
#include "../src/engine_editor.cc"
#include "../src/engine_menu.cc"
#include "../src/engine_stream.cc"
#include "../src/engine_widget.cc"
#include "../src/entry.cc"
#include "../src/error.cc"
#include "../src/evaluator.cc"
#include "../src/evaluator_settings.cc"
#include "../src/evaluator_settings_editor.cc"
#include "../src/evaluator_widget.cc"
#include "../src/file_dialog.cc"
#include "../src/filename.cc"
#include "../src/format.cc"
#include "../src/frame.cc"
#include "../src/game.cc"
#include "../src/game_archive.cc"
#include "../src/game_archive_editor.cc"
#include "../src/game_archive_stream.cc"
#include "../src/game_editor.cc"
#include "../src/game_info.cc"
#include "../src/game_info_editor.cc"
#include "../src/game_list.cc"
#include "../src/game_stream.cc"
#include "../src/generator.cc"
#include "../src/hash_table.cc"
#include "../src/image_widget.cc"
#include "../src/inform.cc"
#include "../src/input_reader.cc"
#include "../src/install_dir.cc"
#include "../src/internet.cc"
#include "../src/internet_account_editor.cc"
#include "../src/internet_interaction_window.cc"
#include "../src/internet_window.cc"
#include "../src/io_child_process.cc"
#include "../src/label.cc"
#include "../src/labeled_entry.cc"
#include "../src/labeled_entry_table.cc"
#include "../src/labeled_spin_button.cc"
#include "../src/legal.cc"
#include "../src/legal_info_widget.cc"
#include "../src/legal_move_list.cc"
#include "../src/list.cc"
#include "../src/main.cc"
#include "../src/match_player.cc"
#include "../src/match_window.cc"
#include "../src/material_widget.cc"
#include "../src/menubar.cc"
#include "../src/menu_callback.cc"
#include "../src/message_receiver.cc"
#include "../src/move.cc"
#include "../src/moveable.cc"
#include "../src/notation.cc"
#include "../src/notation_editor.cc"
#include "../src/notation_stream.cc"
#include "../src/opening_book.cc"
#include "../src/opening_settings_editor.cc"
#include "../src/opening_widget.cc"
#include "../src/option_menu.cc"
#include "../src/owned_color_editor.cc"
#include "../src/packer.cc"
#include "../src/paned.cc"
#include "../src/piece_radio_button.cc"
#include "../src/piece_widget.cc"
#include "../src/pixmap.cc"
#include "../src/player.cc"
#include "../src/players_display.cc"
#include "../src/players_editor.cc"
#include "../src/player_widget.cc"
#include "../src/pointer.cc"
#include "../src/position.cc"
#include "../src/position_editor.cc"
#include "../src/position_stream.cc"
#include "../src/process.cc"
#include "../src/process_usage.cc"
#include "../src/promotion_chooser.cc"
#include "../src/radio_group.cc"
#include "../src/raw_pgn.cc"
#include "../src/scaled_board_image.cc"
#include "../src/scroll_widget.cc"
#include "../src/settings.cc"
#include "../src/simple_notation.cc"
#include "../src/socket.cc"
#include "../src/spin_button.cc"
#include "../src/start_window.cc"
#include "../src/status_bar.cc"
#include "../src/stream.cc"
#include "../src/stream_file.cc"
#include "../src/string.cc"
#include "../src/text_button.cc"
#include "../src/text_view.cc"
#include "../src/time.cc"
#include "../src/toolbar.cc"
#include "../src/variation.cc"
#include "../src/vector.cc"
#include "../src/verbose.cc"
#include "../src/widget.cc"
#include "../src/window.cc"
#include "../src/xboard_server.cc"
#include "../src/about.cc"
#include "../src/alpha_image.cc"
#include "../src/arg.cc"
#include "../src/board_image.cc"
#include "../src/board_settings_reset.cc"
#include "../src/fen.cc"
#include "../src/format_time.cc"
#include "../src/gtk_timer.cc"
#include "../src/gui_execute.cc"
#include "../src/home.cc"
#include "../src/icon.cc"
#include "../src/image.cc"
#include "../src/internet_account_stream.cc"
#include "../src/magic.cc"
#include "../src/moves.cc"
#include "../src/nag.cc"
#include "../src/notation_reset.cc"
#include "../src/parse_fen.cc"
#include "../src/parse_move.cc"
#include "../src/parser.cc"
#include "../src/pgn.cc"
#include "../src/piece_name.cc"
#include "../src/pixmap_stream.cc"
#include "../src/png.cc"
#include "../src/randomize.cc"
#include "../src/read_line.cc"
#include "../src/score.cc"
#include "../src/squares_touched.cc"
#include "../src/tmp_dir.cc"
#include "../src/truncate.cc"
#include "../src/version_number.cc"
#include "../src/execute.cc"
#include "../src/line_reader.cc"
#include "../src/printify_char.cc"
