#include "ask_dialog.hh"

#include "ask.hh"
#include "format.hh"
#include "icon.hh"

#include <libgnomeui/gnome-messagebox.h>
#include <gtk/gtksignal.h>

void Ask_Dialog::Open(String question,
		      String new_msg_edited,  
		      Message_Receiver &new_owner,
		      GtkWidget *parent,
		      const gchar *a, const gchar *b, const gchar *c)
{
	assert (parent != NULL); 

	if (widget != NULL)
	{
		return;
	}

	msg_edited= new_msg_edited; 
	owner= new_owner; 

	choice= -1;

#if 1-1
	question= Format("<strong>%s</strong>", question());
	/* Markup as described by the HIG should be used, but
	 * GnomeMessageBox apparently doesn't use markup. 
	 */
#endif

	widget= gnome_message_box_new(question(),
				      GNOME_MESSAGE_BOX_QUESTION,
				      a, b, c, NULL);


	gnome_dialog_set_default(GNOME_DIALOG(widget), 2); 

	gtk_signal_connect(GTK_OBJECT(widget), "clicked", 
			   GTK_SIGNAL_FUNC(& Signal_Clicked), this);

	gtk_signal_connect(GTK_OBJECT(widget), "close", 
			   GTK_SIGNAL_FUNC(& Signal_Close), this);


	gtk_window_set_transient_for(GTK_WINDOW(widget), GTK_WINDOW(parent));
	gnome_dialog_grab_focus(GNOME_DIALOG(widget), 0);
	Set_Icon(GTK_WINDOW(widget));
	gnome_dialog_set_default(GNOME_DIALOG(widget), 2); 
	gnome_dialog_grab_focus(GNOME_DIALOG(widget), 2); 
	gtk_widget_show(widget); 
}

void Ask_Dialog::Close()
{
	if (widget == NULL)
		return; 

	gtk_object_destroy(GTK_OBJECT(widget));

	widget= NULL;
}

void Ask_Dialog::Signal_Clicked(GtkWidget *, 
				gint argl,
				gpointer data)
{
	Ask_Dialog &fd= *(Ask_Dialog *)data;
	fd.widget= NULL; 
	fd.choice= argl;
	fd.owner().MR_Receive(fd.msg_edited); 
}

gboolean Ask_Dialog::Signal_Close(GtkWidget *, gpointer data)
{
	Ask_Dialog &fd= *(Ask_Dialog *)data;
	fd.widget= NULL; 
	if (fd.choice < 0)  fd.choice= ask_cancel;
	return FALSE;
}
