#ifndef ASK_DIALOG_HH
#define ASK_DIALOG_HH

/* A question dialog box */ 

#include "string.hh"
#include "widget.hh"

#include <gtk/gtkwidget.h>
#include <gtk/gtkstock.h>

class Ask_Dialog
{
public:
	Ask_Dialog()  :  widget(NULL)  {  }
	~Ask_Dialog() { assert (widget == NULL);   }

	void Open(String question,
		  String msg_edited,  
		  Message_Receiver &owner,
		  GtkWidget *parent,
		  const gchar * = GTK_STOCK_NO, 
		  const gchar * = GTK_STOCK_CANCEL, 
		  const gchar * = GTK_STOCK_YES);
	void Open(String question,
		  String msg_edited,
		  Widget &widget,/* owner and it's window is parent */
		  const gchar *s0 = GTK_STOCK_NO, 
		  const gchar *s1 = GTK_STOCK_CANCEL, 
		  const gchar *s2 = GTK_STOCK_YES)
		{
			Open(question,
			     msg_edited,
			     widget,
			     widget.Root().Get(),
			     s0,s1,s2);
		}
		  
	void Close();
	int Get_Value()  {  return choice; }
	bool Have_Read()  { return true;   }

private:
	GtkWidget *widget;
	String msg_edited;
	Pointer <Message_Receiver> owner;
	int choice;
	/* -1 when closed, or the number */ 

	static void Signal_Clicked(GtkWidget *, gint, gpointer);
	static gboolean Signal_Close(GtkWidget *, gpointer);
};

#endif /* ! ASK_DIALOG_HH */ 
