#ifndef BOARD_SETTINGS_HH
#define BOARD_SETTINGS_HH

#include "rgb.hh"
#include "pointer.hh"

/* flags */ 
enum {bs_turned         = 1 << 0,
      bs_no_frame       = 1 << 1,
      bs_square_names   = 1 << 2,
      bs_no_smooth      = 1 << 3,
      bs_tutor          = 1 << 4,
      bs_no_highlight_last = 1 << 5,
      bs_riffled        = 1 << 6,

      bs_count= 7};

/* color indices */ 
enum {c_light,         /* light squares           white       */
      c_dark,          /* dark_squares            light gray  */
      c_last_move,     /* last move circle        yellow      */
      c_frame,         /* frame                   dark gray   */
      c_selection,     /* selected square         blue        */
      c_text,          /* all text                black       */

      c_count,

      c_focus_selection,  /* not saved */ 
};


class Board_Settings
	:  virtual public Pointed
{
public:
	int flags; /* bs_* */ 
	RGB colors[c_count];
	
	/* implemented in BOARD_SETTINGS_RESET */ 
	void Reset();
	static const char *Get_Default_Configuration_Name();
};

#endif /* ! BOARD_SETTINGS_HH */
