#ifndef BOARD_SETTINGS_EDITOR_HH
#define BOARD_SETTINGS_EDITOR_HH

#include "board_settings.hh"
#include "board_settings_stream.hh"
#include "check_box.hh"
#include "color_chooser.hh"
#include "gettext.hh"
#include "configuration_editor.hh"

class Board_Settings_Editor
	:  public Configuration_Editor <Board_Settings>
{
public:
	const char *EW_Type_Name() const  { return _("Board Preferences");    }
	const char *Get_Type_Name() const { return "board_settings";          }

private:
	V_Packer color_packer, options_packer;
	Color_Chooser color_choosers[c_count];
	Check_Box option_boxes[bs_count];

	bool CE_Open(Pointer <Widget> parent, const Board_Settings &);

	bool OE_Retrieve(Board_Settings &);
	void OE_Update(const Board_Settings &);

	int EW_Use();
};

#endif /* ! BOARD_SETTINGS_EDITOR_HH */
