#include "board_settings_editor.hh"

#include "magic.hh"

bool Read_Stream(FILE *file, 
		 Board_Settings *settings)
{
	if (! Magic::Read(file, "Board_Settings"))  return false;

	if (1 != fscanf(file, " %d\n", & settings->flags))
		return false;
	for (int i= 0;  i < c_count;  ++i)
		if (3 != fscanf(file,
				" %d %d %d\n",
				& settings->colors[i].r,
				& settings->colors[i].g,
				& settings->colors[i].b))
		{
			if ( i < 2 )  return false; 
			Board_Settings def;
			def.Reset();
			for (int j= i;  j < c_count;  ++j)
				settings->colors[j]= def.colors[j]; 
		}
	
	return true; 
}

bool Write_Stream(FILE *file, 
		  const Board_Settings *settings)
{
	/* Don't save turnedness. */

	if (! Magic::Write(file, "Board_Settings"))  return false;

	if (0 > fprintf(file,
			"%d\n",
			settings->flags & (~ bs_turned)))
		return false;

	for (int i= 0;  i < c_count;  ++i)
	{
		if (0 > fprintf(file,
				"%d %d %d\n",
				settings->colors[i].r,
				settings->colors[i].g,
				settings->colors[i].b))
			return false;
	}

	return true;
}
