#ifndef BUTTON_BAR_HH
#define BUTTON_BAR_HH

#include "packer.hh"
#include "text_button.hh"
#include "vector.hh"
#include "buffer.hh"
#include "string.hh"

template <class T>
class Button_Bar
	:  public T
{
public:

	bool Open(Pointer <Widget> parent)
		{
			if (T::Open(parent))
			{
				return true;
			}
			else
				return false;
		}

	void Append(String msg,
		    String text,
		    bool sensitive= true)
		{
			Append <Text_Button> (Text_Button::Open_Info(msg_click, text, sensitive));
		}

	void Append_Stock(String msg,
			  const char *stock,
			  bool sensitive= true)
		{
			Append <Text_Button> (Text_Button::Open_Info(msg, "", enabled, stock));
		}
	
	Text_Button &Get(int index)
		{
			return buttons[index](); 
		}

private:

	Vector <Dynamic <Text_Button> > buttons;

	template <class U> 
	bool Append(typename U::Open_Info open_info)
		{
			if (! buttons.Set(*buttons + 1))
				return false;
			Dynamic <U> u;
			if (! u.Alloc())
			{
				buttons= -1;
				return false;
			}
			if (! u().Open(this,
				       open_info))
			{
				buttons= -1;
				return false;
			}
			u.Transfer_To(buttons[-1]);
			return true; 
		}
};

typedef Button_Bar <V_Packer> V_Button_Bar;
typedef Button_Bar <H_Packer> H_Button_Bar;

#endif /* ! BUTTON_BAR_HH */
