#ifndef CLOCK_HH
#define CLOCK_HH

/* GnomeUI should really have a clock.  */

#include "drawing_area.hh"

class Clock
	:  public Drawing_Area
{
public:

	bool Open(Pointer <Widget> parent)
		{
			time= 0;
			return Drawing_Area::Open(parent);
		}

	void Set(int new_time)
		{
			time= new_time;
			Invalidate();
		}

	int Get() const 
		/* seconds */
		{
			assert(Is());
			return time;
		}

private:

	int time; 
	/* seconds */

	void Wdg_Get_Size_Request(int & width  ,
				  int &  height  ,
				  bool & resizeable  )
		{
			width= height= 3 * unit;
			resizeable= false; 
		}

	void Wdg_Draw(Canvas &canvas); 
};

#endif /* ! CLOCK_HH */
