#include "color_chooser.hh"

#include <gtk/gtklabel.h>

bool Color_Chooser::Open(Pointer <Widget> parent,
			 RGB new_color,
			 String text)
{
	if (! H_Packer::Open(parent, dialog_unit/2))  return false;

	color= new_color;

	if (! button.Buttoned <Color_Widget> ::Open(this, String("edit"), color)) return false;
	if (! label.Open(this, text, 0.0, "", true))  return false;
	gtk_label_set_mnemonic_widget(GTK_LABEL(label.Get()), button.Get());

	return true; 
}

void Color_Chooser::Wdg_Close()
{
	editor.Close();
	H_Packer::Wdg_Close();
}

void Color_Chooser::MR_Receive(String message)
{
	if (message == "edited")
	{
		color= editor.Get_Value();
		button().Set_Color(color);
		editor.Have_Read(); 
	}
	else if (message == "edit")
	{
		editor.Open("edited", 
			    *this,
			    RGB(color));
	}

	else 
		H_Packer::MR_Receive(message);
}

void Color_Chooser::Set_Color(RGB new_color)
{
	editor.Close(); 
	color= new_color; 
	button().Set_Color(new_color); 
}
