#ifndef CONF_MENU_HH
#define CONF_MENU_HH

/* Managed settings that can be saved.  Stock settings are found in 
 * "share/MODULE/", where MODULE is e.g. "notation".  Settings saved
 * by the user are saved in "~/.babychess/MODULE.saved/". 
 */

#include "list.hh"
#include "entry.hh"
#include "text_button.hh"
#include "packer.hh"
#include "label.hh"
#include "conf.hh"
#include "dynamic.hh"

class Conf_Menu
	:  public Table
{
public:

	class Saver
		:  virtual public Pointed
	{
	public:
		virtual bool S_Save(String) { return false; }
		virtual bool S_Load(String) { return false; }
		virtual const char *Get_Type_Name() const { return NULL; }
	};

	bool Open(Pointer <Widget> parent, 
		  const char *type_name, 
		  Saver &saver);
	void Save();
	/* Must be called if the value is used.  */
	void Cancel();
	/* Restore the initial valeu of EXACT_NAME. 
	 */

private:
	List list;
	Entry entry;
	Text_Button save_button, remove_button; 
	Label blank;

	const char *type_name;
	Pointer <Saver> saver; 

	bool in_list;

	String initial_exact_name;
	Dynamic <Conf_Dir> conf_dir; 

	void MR_Receive(String);
	void Wdg_Close();

	bool Save_Exact(String exact_name);
};

#endif /* ! CONF_MENU_HH */ 
