#include "context_menu.hh"

#include "menu_callback.hh"

#include <libintl.h>
#include <gtk/gtkcheckmenuitem.h>

void Context_Menu::Popup()
{
	gtk_menu_popup(menu,
		       NULL, NULL, NULL, NULL,
		       0, 0);
}

void Context_Menu::Close()
{
	if (item_factory == NULL)
		return; 

	if (menu != NULL)
	{
		gtk_object_destroy(GTK_OBJECT(menu));
	}

	gtk_object_destroy(GTK_OBJECT(item_factory));
}

Context_Menu::Context_Menu(int count,
			   GtkItemFactoryEntry menu_items[],
			   Widget &receiver,
			   const char *(*translate_func)(const char*))
{
	item_factory= gtk_item_factory_new(GTK_TYPE_MENU, "<main>", NULL);

	if (item_factory == NULL)
	{
		menu= NULL;
		return;
	}

	if (!translate_func)  translate_func= (const char *(*)(const char *))gettext;
	gtk_item_factory_set_translate_func(item_factory, (GtkTranslateFunc)translate_func, 0, NULL); 

	gtk_item_factory_create_items(item_factory, count, menu_items, &receiver);
	
	menu= GTK_MENU(gtk_item_factory_get_widget(item_factory, "<main>")); 
}

Context_Menu::~Context_Menu()
{
	Close();
}

void Context_Menu::Set_Active(const char *name, 
			      bool active)
{
	menu_callback_active= false;
	gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(gtk_item_factory_get_item(item_factory, name)), active);
	menu_callback_active= true;
}

