#ifndef CONTEXT_MENU_HH
#define CONTEXT_MENU_HH

#include "context_menu.hh"

#include <gtk/gtkitemfactory.h>
#include <gtk/gtkmenu.h>

class Widget;


class Context_Menu
{
public:

	Context_Menu(int count,
		     GtkItemFactoryEntry menu_items[],
		     Widget &receiver,
		     const char *(*translate_func)(const char*)= NULL);

	~Context_Menu();

	void Popup();
	void Set_Active(const char *name, bool active);

private:

	/* Both variables are set in the constructor. 
	 */
	GtkItemFactory *item_factory; 
	GtkMenu *menu;

	void Close();
	/* called only from destructor */ 
};

#endif /* ! CONTEXT_MENU_HH */
