#ifndef ENGINE_EDITOR_HH
#define ENGINE_EDITOR_HH

#include "engine.hh"
#include "configuration_editor.hh"
#include "gettext.hh"
#include "engine_stream.hh"
#include "engine_widget.hh"

class Engine_Editor
	:  public Configuration_Editor <Engine>
{
public:
	const char *EW_Type_Name() const  { return _("Choose an Engine");    }
	const char *Get_Type_Name() const { return "engine";                 }

private:
	Engine_Widget engine_widget; 

	bool CE_Open(Pointer <Widget> parent, const Engine &);

	bool OE_Retrieve(Engine &object); 
	void OE_Update(const Engine &engine)
		{
			engine_widget.Update(engine); 
		}
};

#endif /* ! ENGINE_EDITOR_HH */ 
