#ifndef ENGINE_MENU_HH
#define ENGINE_MENU_HH

#include "option_menu.hh"
#include "packer.hh"
#include "label.hh"
#include "text_button.hh"
#include "engine.hh"
#include "conf.hh"
#include "engine_editor.hh"
#include "owned_editor.hh"

class Engine_Menu
	:  public H_Packer
{
public:
	bool Open(Pointer <Widget> parent, 
		  const Engine &,
		  String msg_change= "");
	void Update(const Engine &)
		{ }
	void Retrieve(Engine &new_engine);
	String Name() const;

private:
	Option_Menu menu;
	Text_Button button; 

	/*Dynamic*/std::auto_ptr <Conf_Dir> conf_dir;
	int stock_count; 
	Owned_Editor <Engine_Editor> engine_editor; 
	Engine engine; 

	String msg_change;

	void Wdg_Close();
	
	void MR_Receive(String); 

	void Update_List(); 
};

#endif /* ! ENGINE_MENU_HH */ 

