#include "engine_widget.hh"

bool Engine_Widget::Open(Pointer <Widget> parent, const Engine &engine)
{
	if (! V_Packer::Open(parent, dialog_unit))  return false;
	
	if (! type_chooser.Open(this, "type", _("Engine type"), 1))        
		return false;
	type_chooser() << "_BabyChess"
		       << _("An _XBoard compatible engine");
	
	if (! program.Open(this, _("_XBoard engine")))  return false;

	Update(engine);
	
	return true;
}

void Engine_Widget::Update(const Engine &engine)
{
	type_chooser->Set_Selection(engine.type);
	program.entry.Set(engine.program);
	MR_Receive("type");
}

void Engine_Widget::MR_Receive(String message)
{
	if (message == "type")
	{
		gtk_widget_set_sensitive
			(program.entry.Get(),
			 type_chooser->Selection() == et_xboard);
	}
	else
		V_Packer::MR_Receive(message); 
}

bool Engine_Widget::Retrieve(Engine &engine)
{
	engine.type= type_chooser->Selection();
	if (engine.type < 0)  engine.type= 0;
	engine.program= program.entry.Text();
	return true;
}
