#include "execute.hh"

#include "process.hh"

bool Execute(const char *filename,
	     Pointer <const Vector <String> > args)
{
#ifndef NDEBUG
	Verbose_Function();
	if (args)
	{
		Verbose("\targs= ");
		for (int i= 0; i < *args();  ++i)
			Verbose("\targs[%d]= \"%s\"",
				i,
				args()[i]());
	}
	else
	{
		Verbose("\targs:  empty");
	}
#endif /* ! NDEBUG */ 
	pid_t process;
	Vector <String> empty_args;
	return Process_Create(filename,
			      args.Is () ? args() : empty_args,
			      false,
			      & process);
}
