#include "gui_execute.hh"

#include "execute.hh"
#include "inform.hh"
#include "format.hh"
#include "install_dir.hh"
#include "filename.hh"
#include "gettext.hh"

bool GUI_Execute(String program_name,
		 Pointer <const Vector <String> > args,
		 Pointer <Widget> widget)
{
	Vector <String> a;
	if (args)  a= args(); 

	if (program_name)
	{
		if (! a.Set(*a+1))  return false;
		for (int i= *a-1; i > 0; --i)
			a[i]= a[i-1];
		a[0]= "--" + program_name; 
	}
	
	String filename= Install_Dir(id_bin) / "babychess";
	
	if (! Execute(filename(), a))
	{
		
		String text= Format(_("Cannot execute \"%s\""), 
				    "babychess");
		Inform_Error(text, widget); 
		return false;
	}

	return true;   
}
