#ifndef GUI_EXECUTE_HH
#define GUI_EXECUTE_HH

/* For GUI programs:  Execute another GUI program.
 */

#include "string.hh"
#include "pointer.hh"
#include "vector.hh"
#include "widget.hh"

bool GUI_Execute(String mode, /* e.g. edit-game or match */
		 Pointer <const Vector <String> > args= NULL,
		 Pointer <Widget> = NULL);
/* Execute BabyChess in another process.  The program is executed  whithout
 * waiting for termination.  Return whether the program was started.  WIDGET is
 * used as the window that the error message will be transient for.      
 */

Inline bool GUI_Execute(String mode,
			Pointer <Widget> widget)
{
	return GUI_Execute(mode, NULL, widget);
}

Inline bool GUI_Execute(String mode, 
			String arg,
			Pointer <Widget> widget)
{
	Vector <String> args;
	if (! args.Set(1))
		return false;
	args[0]= arg;
	return GUI_Execute(mode, args, widget);
}

Inline bool GUI_Execute(String mode, 
			String arg1, String arg2,
			Pointer <Widget> widget= NULL)
{
	Vector <String> args;
	if (! args.Set(2))
		return false;
	args[0]= arg1;
	args[1]= arg2;
	return GUI_Execute(mode, args, widget);
}

#endif /* ! GUI_EXECUTE_INCLUDED */
