#include "inform.hh"

#include "gettext.hh"
#include "error.hh"
#include "format.hh"

#include <gtk/gtkstock.h>
#include <gtk/gtksignal.h>
#include <libgnomeui/gnome-messagebox.h>

GtkWidget *inform_last;

void Inform(String text,
	    const gchar *message_box_type,
	    Pointer <Widget> transient_for)
{
	Verbose_Function(); 

	inform_last= gnome_message_box_new
		(text(),
		 message_box_type,
		 GTK_STOCK_OK, NULL);
	if (inform_last == NULL)  return;

	if (transient_for)
		gtk_window_set_transient_for
			(GTK_WINDOW(inform_last), 
			 GTK_WINDOW(transient_for->Root().Get()));
	gtk_widget_show(inform_last);
}

void Inform_Error(String what,
		  Pointer <Widget> widget)
{
	Inform(Format("%s%s  %s",  what(), _(":"), Error::Get()()),
	       GNOME_MESSAGE_BOX_ERROR,
	       widget);
}
