#ifndef MATCH_PLAYER_HH
#define MATCH_PLAYER_HH

#include "xboard_server.hh"
#include "player.hh"
#include "install_dir.hh"
#include "filename.hh"
#include "dynamic.hh"
#include "message_receiver.hh"

class Match_Player
{
public:
	virtual ~Match_Player() {}
	virtual void MP_Go()= 0;
	virtual void MP_Move(String)= 0;
	virtual void MP_Take_Back()= 0;
	/* If the engine is to play, take back one move.  If the engine is not
	 * to play, take back two moves. 
	 */
};

class Match_Engine
	:  public Match_Player,
	   private XBoard_Server
{
public:
	Match_Engine(const Engine &engine,
		     String new_message,
		     const Message_Receiver &new_message_receiver);
	operator bool () const 
		{ return XBoard_Server::operator bool(); }

private:
	Pointer <const Message_Receiver> message_receiver;
	String message;

	void MP_Go()
		{ XBoard_Server::Go();  }
	void MP_Move(String move)
		{
			XBoard_Server::Play_Move(move); 
		}
	void MP_Take_Back();
	
	void XS_Move(String move)
		{
			message_receiver->MR_Send(message + " " + move);
		}
};

bool New_Match_Player(Dynamic <Match_Player> &dynamic,
		      const Player &player,
		      String message,
		      const Message_Receiver &);

#endif /* ! MATCH_PLAYER_HH */ 

