#include "menubar.hh"

#include "gettext.hh"

#include <gtk/gtkmenubar.h>
#include <gtk/gtkcheckmenuitem.h>
#include <gtk/gtkwindow.h>

bool Menubar::Open(Pointer <Widget> parent,
		    int count,
		    GtkItemFactoryEntry menu_items[],
		    Widget &receiver)
{
	GtkAccelGroup *accel_group= gtk_accel_group_new();

	item_factory= gtk_item_factory_new
		(GTK_TYPE_MENU_BAR, "<main>",
		 accel_group);

	gtk_item_factory_set_translate_func(item_factory, (GtkTranslateFunc)&gettext, 0, NULL); 

	gtk_item_factory_create_items(item_factory, count, menu_items, &receiver);

	gtk_window_add_accel_group (GTK_WINDOW(parent->Root().Get()), accel_group);

	return Widget::Open
		(parent, 
		 gtk_item_factory_get_widget  
		 (item_factory, "<main>"));
}

void Menubar::Set_Sensitive(const char *item, bool sensitive)
{
	gtk_widget_set_sensitive
		(GTK_WIDGET(gtk_item_factory_get_item
			    (item_factory, item)),
		 sensitive); 
}

void Menubar::Append(int count,
		      GtkItemFactoryEntry menu_items[],
		      Widget &receiver)
{
	gtk_item_factory_create_items(item_factory, count, menu_items, &receiver);
}

bool Menubar::Active(const char *name)
{
	return gtk_check_menu_item_get_active
		(GTK_CHECK_MENU_ITEM
		 (gtk_item_factory_get_item
		  (item_factory, name)));
}

void Menubar::Set_Active(const char *name, 
			      bool active)
{
	menu_callback_active= false;
	gtk_check_menu_item_set_active
		(GTK_CHECK_MENU_ITEM
		 (gtk_item_factory_get_item
		  (item_factory, name)),
		 active);
	menu_callback_active= true;
}
