#ifndef NOTATION_EDITOR_HH
#define NOTATION_EDITOR_HH

#include "configuration_editor.hh"
#include "notation.hh"
#include "check_box.hh"
#include "gettext.hh"
#include "radio_group.hh"
#include "labeled_entry_table.hh"

class Notation_Editor
	:  public Configuration_Editor <Notation> 
{
public:
	const char *EW_Type_Name() const  {  return _("Notation Preferences");    }
	const char *Get_Type_Name() const {  return "notation";                   }

private:
	V_Packer option_packer;
	Framed_Radio_Group type; 
	Check_Box check_box[nt_count]; 
	Labeled_Entry_Table strings;

	bool CE_Open(Pointer <Widget> parent, const Notation &);
	bool OE_Retrieve(Notation &); 
	void OE_Update(const Notation &);

	void MR_Receive(String);

	void Update_Sensitive(); 

	/* convert to and from notation type to the order of the type in the
	 * radio group */
	static int Selection(int options) 
		{ return options & nt_short ? 0 : options & nt_descriptive ? 2 : 1; }
	static int Options(int selection)\
		{ return selection == 0 ? nt_short : selection == 1 ? 0 : nt_descriptive; }	
};

#endif /* NOTATION_EDITOR_HH */ 
