#include "notation_stream.hh"

#include "read_line.hh"
#include "verbose.hh"
#include "magic.hh"

bool Read_Stream(FILE *file, Notation *notation)
{
	if (! Magic::Read(file, "Notation"))  return false;

	int p= fscanf(file, "%d\n", & notation->options);
	if (p != 1)  return false;
	int i= 0;
	for (; i < s_count;  ++i)
	{
		if (! Read_Line(file, (*notation)[i]))  break;
	}

	for (; i < s_count;  ++i)  (*notation)[i]= san.strings[i];

	return true;
}


bool Write_Stream(FILE *file,  const Notation *notation)
{
	if (! Magic::Write(file, "Notation"))  return false;
	if (0 > fprintf(file, "%d\n", notation->options))  return false;
	
	for (int i= 0;  i < s_count;  ++i)
		if (0 > fprintf(file, "%s\n", (*notation)[i]()))  return false;
	return true; 
}
