#include "opening_widget.hh"

#include "gettext.hh"

#include <gtk/gtklabel.h>

bool Opening_Widget::Open(Pointer <Widget> parent,
			  Menubar &new_menubar,
			  const Game &new_game,
			  const char *new_msg_options_changed)
{
	if (! V_Packer::Open(parent))
		return false;

	if (! label.Open(this))  return false;
	gtk_label_set_line_wrap(GTK_LABEL(label.Get()), TRUE);

	preferences.Open(*this, "edited");

	Opening_Book::Open();

	menubar= new_menubar; 
	game= new_game; 
	msg_options_changed= new_msg_options_changed; 

	Update();
	Update_Menu();

	return true;
}

void Opening_Widget::Update()
{
	Vector <String> names;
	if (Opening_Book::Is())
		Opening_Book::Get(game(), names, preferences->flags);

	if (*names)
	{
		gtk_widget_show(label.Get());
		String text= names[0];
		for (int i= 1; i < *names; ++i)
		{
			text += ", ";
			text += names[i];
		}
		label.Set(text); 
	}
	else
		gtk_widget_hide(label.Get()); 
}

void Opening_Widget::Wdg_Close()
{
	preferences.Close();
	menubar= NULL; 
	game= NULL; 
	V_Packer::Wdg_Close(); 
}

void Opening_Widget::MR_Receive(String message)
{
	if (message == "edit")
	{
		preferences.Edit();
	}
	else if (message == "edited")
	{
		Update();
		Update_Menu();
		Parent_Receive_Message(msg_options_changed); 
	}
	else if (message == "subvariation")
	{
		preferences.Get_Change_Value().flags ^= op_subvariation;
		preferences.Changed();
		Set_Menu_Subvariation();
		Update();
		Parent_Receive_Message(msg_options_changed); 
	}
	else if (message == "alternative")
	{
		preferences.Get_Change_Value().flags ^= op_alternative;
		preferences.Changed();
		Set_Menu_Alternative();
		Update(); 
		Parent_Receive_Message(msg_options_changed); 
	}
	else
		V_Packer::MR_Receive(message); 
}
