#include "socket.hh"

/* Super-cheap implementation of a socket using telnet. 
 */

#include "format.hh"
#include "error.hh"

#include <errno.h>

bool Socket::Open(String host, int port)
{
	if (! host.Is())
	{
		errno= EINVAL; 
		return false;
	}

	Vector <String> args;
	if (! args.Set(1))
		return false;
	args[0]= host();

	if (port >= 0)
	{
		if (! args.Set(2))
			return false;
		args[1]= Format("%d", port); 
	}
	return IO_Child_Process::Open("telnet", args);
}
