#include "start_window.hh"

#include "gui_execute.hh"
#include "format.hh"
#include "install_dir.hh"
#include "filename.hh"
#include "about.hh"
#include "gettext.hh"

#include <gtk/gtkimage.h>
#include <gtk/gtkstock.h>
#include <gtk/gtkbox.h>

Start_Window::Info Start_Window::info[Start_Window::size]=
{{N_("_Play"),                   "match"},
 {N_("Play on the _internet"),   "internet"},
 {N_("New game _archive"),       "edit-game-archive"},
 {N_("New _game"),               "edit-game"},
 {N_("New _position"),           "edit-position"}};

bool Start_Window::Open(Open_Info)
{
	if (! Window::Open("BabyChess", (GdkPoint){-1, -1}))  return false;

	H_Packer::Open_Info oi(dialog_unit, false, false);
	if (! main_packer.Open(this, oi))  goto close;

	gtk_container_set_border_width(GTK_CONTAINER(Get()), dialog_unit); 

	{
		String filename= About_Get_Image_Filename();
		Verbose_Str(filename());
		GtkWidget *image= gtk_image_new_from_file(filename());
		if (image == NULL)  
		{
			Verbose("\t image == NULL");
			goto close;
		}
		Verbose_Pointer(image);

		gtk_box_pack_start_defaults(GTK_BOX(main_packer.Get()),
					    GTK_WIDGET(image));
		gtk_widget_show(GTK_WIDGET(image));
	}

	if (! button_packer.Open(main_packer, dialog_unit/2))  goto close;

	for (int i= 0;  i < size;  ++i)
	{
		if (i == 2)
			first_bevel.Open(button_packer);
		if (! buttons[i].Open(button_packer, Format("start %d", i), _(info[i].text)))
		{
			goto close; 
		}
	}

	bevel.Open(button_packer); 
	about_button.Open(button_packer, "about", _("_About")); 
	close_button.Open(button_packer, "ok", "", true, GTK_STOCK_CLOSE); 

	return true;

 close:
	Window::Close(); 
	return false;
}

void Start_Window::MR_Receive(String message)
{
	if (!memcmp(message(), "start ", 6))
	{
		int i;
		if (1!=sscanf(message()+6, "%d", &i))  return;
		if (i < 0 || i >= size)  return;
		GUI_Execute(info[i].mode, this);
	}
	else if (message == "about")
	{
		About(); 
	}
	else
		Window::MR_Receive(message);
}
