#include "stream.hh"

#include <unistd.h>

#if 0
void (*stream_hook)(int fd)= NULL;
/* Called for each FD created.  Set in Set_FD_Creation_Hook().  The
 * PROCESS module registers a hook that sets each FD opened to
 * close-on-exec.  
 */

void Stream_Call_Hook(int fd)
{
	if (stream_hook != NULL)
		stream_hook(fd);
}
#endif /* 0 */ 

#if 0
bool Stream::Open_FD(int fd,
		     const char *opentype)
{
	assert (! Is());
	assert (fd >= 0);

	FILE *fdo= fdopen(fd, opentype);
	if (fdo == NULL)
	{
		return false;
	}
	file= fdo;

//	Stream_Call_Hook(fileno(file));

	return true;
}
#endif /* 0 */ 

bool Stream::Open(const char *filename, const char *opentype)
{
	assert(file == NULL);

	file= fopen(filename, opentype);

	if (file == NULL)
		return false;

//	Stream_Call_Hook(fileno(file));

	return true;
}

bool Stream::Dup(int fd, const char *opentype)
{
	assert (fd >= 0);
	assert (file == NULL);
  
	int new_fd= dup(fd);

	if (new_fd < 0)
		return false;

	file= fdopen(new_fd, opentype);

	if (file == NULL)
	{
		close(new_fd);
		return false;
	}

//	Stream_Call_Hook(fileno(file));

	return true;
}

Stream::~Stream()
{
	assert (file == NULL);
	/* Just closing the file here doesn't work.  fclose() may report an
	 * error which would not be noticed.  Always call Close() and check the
	 * return value. 
	 */

	if (file != NULL)  Close();
}

#if 0
void Stream::Set_FD_Creation_Hook(void (*f)(int fd))
{
	assert (stream_hook == NULL);
	stream_hook= f;
}
#endif /* 0 */ 
