#ifndef STREAM_FILE_HH
#define STREAM_FILE_HH

/* Read and write an object from/to a file.  Functions of the STREAM
 * module are used.  Return FALSE on error.  
 */

//#include "stream.hh"
#include "string.hh"

#include <stdio.h>

bool Read_From_File_Helper(const char *filename,
			   void *object,
			   bool (*) (FILE *, void *));

template <class Type> 
bool Read_From_File(const char *filename,
		    Type &object)
{
	typedef bool (*exact_type) (FILE *, Type *);
	exact_type p= &Read_Stream;
	return Read_From_File_Helper
		(filename,
		 &object,
		 (bool (*) (FILE *, void *)) p);

#if 0
	Stream stream;
	
	if (! stream.Open(filename, "rb"))
		return false;


	if (! Read_Stream(stream(), &object))
	{
		stream.Close(); 
		return false;
	}

	if (! stream.Close())
		return false;

	return true;
#endif /* 0 */ 
}

bool Write_To_File_Helper(const char *filename,
			  const void *object,
			  bool (*) (FILE *, const void *));

template <class Type>
bool Write_To_File(const char *filename,
		   const Type &object)
{
	typedef bool (*exact_type) (FILE *, const Type *);
	exact_type p= &Write_Stream;
	return Write_To_File_Helper
		(filename, &object, (bool (*) (FILE *, const void *)) p);

#if 0
	Stream stream;

	String tmp_name= filename;
	tmp_name += ".backup";

	if (! stream.Open(tmp_name(), "wb"))
		return false;
	if (! Write_Stream(stream(), &object))
	{
		stream.Close(); 
		goto remove_tmp;
	}
	if (! stream.Close())
		goto remove_tmp;
	if (0 > rename(tmp_name(), filename))  return false;



	return true;

 remove_tmp:
	unlink(tmp_name());
	return false;
#endif /* 0 */ 
}

String Write_To_Tmp_File_Helper
(const void *object, 
 bool (*) (FILE *, const void *));

template <class Type>
String Write_To_Tmp_File(const Type &object)
{
	typedef bool (*exact_type) (FILE *, const Type *);
	exact_type p= &Write_Stream;
	return Write_To_Tmp_File_Helper
		(&object, (bool (*) (FILE *, const void *)) p);
#if 0
	String filename= Format("%s/babychess.stream_file.XXXXXX", Tmp_Dir());
	int fd= mkstemp(filename.c());
	if (fd < 0)  return "";
	Stream stream;
	if (! stream.Open_FD(fd, "w"))
		goto close_fd;
	if (! Write_Stream(stream(), &object))
	{
		stream.Close(); 
		goto unlink;
	}
	if (! stream.Close())
		goto unlink;

	return filename();
	
 close_fd:
	close(fd);
 unlink:
	unlink(filename());
	return "";
#endif /* 0 */ 
}

#endif /* ! STREAM_FILE_HH */
