#ifndef TEXT_VIEW_HH
#define TEXT_VIEW_HH

#include "string.hh"
#include "widget.hh"

class Text_View
	:  public Widget 
{
public:

	struct Open_Info
	{
		String text;
		bool editable;
		String changed;

		Open_Info(String new_text= "",
			  bool new_editable= false)
			:  text (new_text),
			   editable (new_editable)
			{ }
	};

	bool Open(Pointer <Widget> parent,
		  String text= "",
		  bool editable= false);
	bool Open(Pointer <Widget> parent,
		  Open_Info open_info)
		{
			return Open(parent, 
				    open_info.text,
				    open_info.editable);
		}

	void Append_Text(String text);

	void Wdg_Get_Size_Request(int &width,
				  int &height,
				  bool &resizeable);

	void Scroll_End();

	void Clear();
	String Get_Text() const;
	void Set_Text(String text)
		{
			Clear();
			Append_Text(text); 
		}
};

#endif /* ! TEXT_VIEW_HH */ 
