#Boa:Dialog:preferences
#TunaPie (c)2005 James Stone. Released under the GNU GPL.
#Written using Boa-Constructor.
#Version 0.0.1 2/3/05

from wxPython.wx import *
from wxPython.lib.stattext import wxGenStaticText
import tuner

def create(parent):
    return preferences(parent)

[wxID_PREFERENCES, wxID_PREFERENCESAUDIOPATH, wxID_PREFERENCESBUTTON1, 
 wxID_PREFERENCESBUTTON2, wxID_PREFERENCESGENSTATICTEXT1, 
 wxID_PREFERENCESGENSTATICTEXT2, wxID_PREFERENCESGENSTATICTEXT3, 
 wxID_PREFERENCESGENSTATICTEXT4, wxID_PREFERENCESRIPPATH, 
 wxID_PREFERENCESTERMPATH, wxID_PREFERENCESVIDEOPATH, 
] = map(lambda _init_ctrls: wxNewId(), range(11))

class preferences(wxDialog):
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wxDialog.__init__(self, id=wxID_PREFERENCES, name='preferences',
              parent=prnt, pos=wxPoint(308, 209), size=wxSize(376, 193),
              style=wxDEFAULT_DIALOG_STYLE, title='Preferences')
        self.SetClientSize(wxSize(376, 193))

        self.genStaticText1 = wxGenStaticText(ID=wxID_PREFERENCESGENSTATICTEXT1,
              label='Full path to audio player:', name='genStaticText1',
              parent=self, pos=wxPoint(8, 16), size=wxSize(140, 14), style=0)

        self.genStaticText2 = wxGenStaticText(ID=wxID_PREFERENCESGENSTATICTEXT2,
              label='Full path to vnc player:', name='genStaticText2',
              parent=self, pos=wxPoint(8, 48), size=wxSize(130, 14), style=0)

        self.button1 = wxButton(id=wxID_PREFERENCESBUTTON1, label='Save',
              name='button1', parent=self, pos=wxPoint(56, 160), size=wxSize(80,
              22), style=0)
        self.button1.SetDefault()
        EVT_BUTTON(self.button1, wxID_PREFERENCESBUTTON1, self.OnButton1Button)

        self.button2 = wxButton(id=wxID_PREFERENCESBUTTON2, label='Cancel',
              name='button2', parent=self, pos=wxPoint(240, 160),
              size=wxSize(80, 22), style=0)
        EVT_BUTTON(self.button2, wxID_PREFERENCESBUTTON2, self.OnButton2Button)

        self.audiopath = wxTextCtrl(id=wxID_PREFERENCESAUDIOPATH,
              name='audiopath', parent=self, pos=wxPoint(152, 16),
              size=wxSize(208, 22), style=0, value='/usr/bin/xmms')

        self.videopath = wxTextCtrl(id=wxID_PREFERENCESVIDEOPATH,
              name='videopath', parent=self, pos=wxPoint(152, 48),
              size=wxSize(208, 22), style=0, value='/usr/bin/mplayer')

        self.genStaticText3 = wxGenStaticText(ID=wxID_PREFERENCESGENSTATICTEXT3,
              label='Full path to x-terminal:', name='genStaticText3',
              parent=self, pos=wxPoint(8, 80), size=wxSize(124, 14), style=0)

        self.genStaticText4 = wxGenStaticText(ID=wxID_PREFERENCESGENSTATICTEXT4,
              label='Full path to streamripper:', name='genStaticText4',
              parent=self, pos=wxPoint(8, 112), size=wxSize(138, 14), style=0)

        self.termpath = wxTextCtrl(id=wxID_PREFERENCESTERMPATH, name='termpath',
              parent=self, pos=wxPoint(152, 80), size=wxSize(208, 22), style=0,
              value='/usr/bin/x-terminal-emulator')

        self.rippath = wxTextCtrl(id=wxID_PREFERENCESRIPPATH, name='rippath',
              parent=self, pos=wxPoint(152, 112), size=wxSize(208, 22), style=0,
              value='/usr/bin/streamripper')

    def __init__(self, parent):
        self._init_ctrls(parent)
        
    def setvars(self,media,video,term,rip,home):
        self.audiopath.SetValue(media)
        self.videopath.SetValue(video)
        self.termpath.SetValue(term)
        self.rippath.SetValue(rip)
        self.home=home

    def OnButton2Button(self, event):
        self.Close()

    def OnButton1Button(self, event):
        tuner.writeprefs(self.home,self.audiopath.GetValue(),\
            self.videopath.GetValue(),self.termpath.GetValue(),\
            self.rippath.GetValue())
        self.Close()
